var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Component, Input, ViewChild } from '@angular/core';
import viser from 'viser';
function generateRandomNum() {
    return (Math.floor(new Date().getTime() + Math.random() * 10000)).toString();
}
function retain(obj, attr) {
    var newObj = Object.create(null);
    for (var item in obj) {
        if (obj.hasOwnProperty(item)) {
            var arrAttr = Array.isArray(attr) ? attr : [attr];
            if (arrAttr.indexOf(item) >= 0) {
                newObj[item] = obj[item];
            }
        }
    }
    return newObj;
}
var LiteChart = (function () {
    function LiteChart() {
        this.config = {};
        this.views = {};
        this.chart = null;
        this.viewId = generateRandomNum();
    }
    LiteChart.prototype.combineViewConfig = function (props, config) {
        if (props.data) {
            config.data = props.data;
        }
        if (props.dataMapping) {
            config.dataMapping = props.dataMapping;
        }
        if (props.dataPre) {
            config.dataPre = props.dataPre;
        }
        if (props.scale) {
            config.scale = props.scale;
        }
        if (props.tooltip) {
            config.tooltip = props.tooltip;
        }
        else {
            config.tooltip = true;
        }
        if (props.legend) {
            config.legend = props.legend;
        }
        else {
            config.legend = true;
        }
        if (props.axis) {
            config.axis = props.axis;
        }
        else {
            config.axis = true;
        }
        if (props.guide) {
            config.guide = props.guide;
        }
        return config;
    };
    LiteChart.prototype.combineChartConfig = function (props, config) {
        var chartRetain = [
            'height', 'width', 'animate', 'forceFit',
            'background', 'plotBackground', 'padding',
        ];
        config.chart = retain(props, chartRetain);
        return config;
    };
    LiteChart.prototype.combineSeriesConfig = function (props, config) {
        var regSeries = [
            'pie',
            'sector',
            'line',
            'smoothLine',
            'dashLine',
            'area',
            'stackArea',
            'smoothArea',
            'bar',
            'stackBar',
            'dodgeBar',
            'point',
            'waterfall',
            'funnel',
            'pyramid',
            'radialBar',
            'schema',
            'box',
            'candle',
            'polygon',
            'contour',
            'heatmap',
            'edge'
        ];
        for (var _i = 0, regSeries_1 = regSeries; _i < regSeries_1.length; _i++) {
            var res = regSeries_1[_i];
            if (props[res]) {
                config.series = __assign({}, config.series, { quickType: res });
                break;
            }
        }
        return config;
    };
    LiteChart.prototype.ngAfterViewInit = function () {
        if (this.chart) {
            this.chart.destroy();
        }
        this.initChart();
    };
    LiteChart.prototype.getProps = function (allProps) {
        var strippingProperties = ['chart', 'chartDiv', 'config', 'context', 'viewId', 'views',
            'constructor', 'combineViewConfig', 'combineChartConfig', 'combineContentConfig',
            'ngAfterViewInit', 'getProps', 'combineSeriesConfig', 'getViewChartConfig', 'initChart', 'ngOnChanges', 'renderChart'];
        if (allProps) {
            var properties = {};
            for (var key in allProps) {
                if (strippingProperties.indexOf(key) === -1) {
                    properties[key] = allProps[key];
                }
            }
            return properties;
        }
        return allProps;
    };
    LiteChart.prototype.getViewChartConfig = function (config) {
        var chartProperties = ['forceFit', 'height', 'width', 'container'];
        var chart = {};
        if (config.chart) {
            for (var key in config.chart) {
                if (chartProperties.indexOf(key) > -1) {
                    chart[key] = config.chart[key];
                }
            }
        }
        return chart;
    };
    LiteChart.prototype.initChart = function (rerender) {
        var name = this.constructor.name;
        var props = this.getProps(this);
        this.combineChartConfig(props, this.config);
        this.combineViewConfig(props, this.config);
        this.combineSeriesConfig(props, this.config);
        this.config.chart = this.getViewChartConfig(this.config);
        this.renderChart(rerender);
    };
    LiteChart.prototype.ngOnChanges = function (changes) {
        if (!this.chart) {
            return;
        }
        this.initChart(true);
    };
    LiteChart.prototype.renderChart = function (rerender) {
        this.config.chart.container = this.chartDiv.nativeElement;
        if (rerender) {
            this.chart.repaint(this.config);
        }
        else {
            this.chart = viser(this.config);
        }
    };
    __decorate([
        Input()
    ], LiteChart.prototype, "data");
    __decorate([
        Input()
    ], LiteChart.prototype, "width");
    __decorate([
        Input()
    ], LiteChart.prototype, "height");
    __decorate([
        Input()
    ], LiteChart.prototype, "dataView");
    __decorate([
        Input()
    ], LiteChart.prototype, "gemo");
    __decorate([
        Input()
    ], LiteChart.prototype, "color");
    __decorate([
        Input()
    ], LiteChart.prototype, "label");
    __decorate([
        Input()
    ], LiteChart.prototype, "radius");
    __decorate([
        Input()
    ], LiteChart.prototype, "innerRadius");
    __decorate([
        Input()
    ], LiteChart.prototype, "forceFit");
    __decorate([
        Input()
    ], LiteChart.prototype, "fields");
    __decorate([
        Input()
    ], LiteChart.prototype, "type");
    __decorate([
        Input()
    ], LiteChart.prototype, "opacity");
    __decorate([
        Input()
    ], LiteChart.prototype, "size");
    __decorate([
        Input()
    ], LiteChart.prototype, "coord");
    __decorate([
        Input()
    ], LiteChart.prototype, "dataMapping");
    __decorate([
        Input()
    ], LiteChart.prototype, "dataPre");
    __decorate([
        Input()
    ], LiteChart.prototype, "scale");
    __decorate([
        Input()
    ], LiteChart.prototype, "axis");
    __decorate([
        Input()
    ], LiteChart.prototype, "guide");
    __decorate([
        Input()
    ], LiteChart.prototype, "series");
    __decorate([
        Input()
    ], LiteChart.prototype, "tooltip");
    __decorate([
        Input()
    ], LiteChart.prototype, "calData");
    __decorate([
        Input()
    ], LiteChart.prototype, "facet");
    __decorate([
        Input()
    ], LiteChart.prototype, "legend");
    __decorate([
        Input()
    ], LiteChart.prototype, "pie");
    __decorate([
        Input()
    ], LiteChart.prototype, "sector");
    __decorate([
        Input()
    ], LiteChart.prototype, "line");
    __decorate([
        Input()
    ], LiteChart.prototype, "smoothLine");
    __decorate([
        Input()
    ], LiteChart.prototype, "dashLine");
    __decorate([
        Input()
    ], LiteChart.prototype, "area");
    __decorate([
        Input()
    ], LiteChart.prototype, "stackArea");
    __decorate([
        Input()
    ], LiteChart.prototype, "smoothArea");
    __decorate([
        Input()
    ], LiteChart.prototype, "bar");
    __decorate([
        Input()
    ], LiteChart.prototype, "stackBar");
    __decorate([
        Input()
    ], LiteChart.prototype, "dodgeBar");
    __decorate([
        Input()
    ], LiteChart.prototype, "point");
    __decorate([
        Input()
    ], LiteChart.prototype, "waterfall");
    __decorate([
        Input()
    ], LiteChart.prototype, "funnel");
    __decorate([
        Input()
    ], LiteChart.prototype, "pyramid");
    __decorate([
        Input()
    ], LiteChart.prototype, "radialBar");
    __decorate([
        Input()
    ], LiteChart.prototype, "schema");
    __decorate([
        Input()
    ], LiteChart.prototype, "box");
    __decorate([
        Input()
    ], LiteChart.prototype, "candle");
    __decorate([
        Input()
    ], LiteChart.prototype, "polygon");
    __decorate([
        Input()
    ], LiteChart.prototype, "contour");
    __decorate([
        Input()
    ], LiteChart.prototype, "heatmap");
    __decorate([
        Input()
    ], LiteChart.prototype, "edge");
    __decorate([
        ViewChild('chartDom')
    ], LiteChart.prototype, "chartDiv");
    LiteChart = __decorate([
        Component({
            providers: [],
            selector: 'LiteChart',
            template: "<div #chartDom></div>"
        })
    ], LiteChart);
    return LiteChart;
}());
export { LiteChart };
//# sourceMappingURL=LiteChart.js.map